###################################################
### chunk number 1: 
###################################################
#line 128 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
options(width = 70, prompt="R> ", digits=4)
### for sampling
set.seed(1234)


###################################################
### chunk number 2: 
###################################################
#line 849 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
library("rEMM")
data(EMMTraffic)
EMMTraffic


###################################################
### chunk number 3: 
###################################################
#line 864 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm <- EMM(threshold=0.2, measure="eJaccard")
build(emm, EMMTraffic)
size(emm)


###################################################
### chunk number 4: 
###################################################
#line 877 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
cluster_counts(emm)


###################################################
### chunk number 5: 
###################################################
#line 883 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
cluster_centers(emm)


###################################################
### chunk number 6: Traffic_graph
###################################################
#line 890 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emm, method="graph")


###################################################
### chunk number 7: 
###################################################
#line 912 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
transition_matrix(emm)


###################################################
### chunk number 8: 
###################################################
#line 917 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
transition_matrix(emm, type="counts")
#transition_matrix(emm, type="log_odds")


###################################################
### chunk number 9: 
###################################################
#line 931 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
transition(emm, "1", "2", type="probability")


###################################################
### chunk number 10: 
###################################################
#line 939 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
predict(emm, n=2, current="2")


###################################################
### chunk number 11: 
###################################################
#line 945 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
predict(emm, n=2, current="2", probabilities=TRUE)


###################################################
### chunk number 12: Traffic_r3
###################################################
#line 961 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm_3removed <- copy(emm)
remove_clusters(emm_3removed, "3")
plot(emm_3removed, method = "graph")


###################################################
### chunk number 13: Traffic_rt52
###################################################
#line 975 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm_52removed <- remove_transitions(copy(emm), "5", "2")
plot(emm_52removed, method = "graph")


###################################################
### chunk number 14: Traffic_m25
###################################################
#line 989 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm_25merged <- merge_clusters(copy(emm), c("2","5"))
plot(emm_25merged, method = "graph")


###################################################
### chunk number 15: Traffic_l
###################################################
#line 1034 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm_fading <- EMM(threshold=0.2, measure="eJaccard", lambda = 1)
build(emm_fading, EMMTraffic)
plot(emm_fading, method = "graph")


###################################################
### chunk number 16: Traffic_lp
###################################################
#line 1054 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
prune(emm_fading, count_threshold=0.1)
plot(emm_fading, method = "graph")


###################################################
### chunk number 17: 
###################################################
#line 1103 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
data("EMMsim")


###################################################
### chunk number 18: sim_data
###################################################
#line 1114 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(EMMsim_train, col="gray", pch=EMMsim_sequence_train)
lines(EMMsim_test, col ="gray")
points(EMMsim_test, col="red", pch=5)
text(EMMsim_test, labels=1:nrow(EMMsim_test), pos=3)


###################################################
### chunk number 19: sim_graph
###################################################
#line 1138 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
emm <- EMM(threshold=0.1, measure="euclidean")
build(emm, EMMsim_train)
plot(emm, method="graph")


###################################################
### chunk number 20: sim_MDS
###################################################
#line 1152 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emm, method="MDS")


###################################################
### chunk number 21: sim_MDS2
###################################################
#line 1176 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emm, method = "MDS", data=EMMsim_train)


###################################################
### chunk number 22: 
###################################################
#line 1250 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
score(emm, EMMsim_test, method="prod", match_cluster="exact", plus_one=FALSE,
initial_transition = FALSE)
score(emm, EMMsim_test, method="sum", match_cluster="exact", plus_one=FALSE,
initial_transition = FALSE)


###################################################
### chunk number 23: 
###################################################
#line 1268 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
transition_table(emm, EMMsim_test, match_cluster="exact", plus_one=FALSE)


###################################################
### chunk number 24: 
###################################################
#line 1302 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
score(emm, EMMsim_test, method="prod")
score(emm, EMMsim_test, method="sum")


###################################################
### chunk number 25: sim_hc
###################################################
#line 1325 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
## find best predicting model (clustering)
k <- 2:10
emmc <- recluster_hclust(copy(emm), k=k, method ="average") 
plot(attr(emmc, "cluster_info")$dendrogram)


###################################################
### chunk number 26: 
###################################################
#line 1341 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
sc <- sapply(emmc, score, EMMsim_test)
names(sc) <- k
sc


###################################################
### chunk number 27: sim_optc_graph
###################################################
#line 1355 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emmc[[which.max(sc)]], method="graph")


###################################################
### chunk number 28: sim_optc_MDS
###################################################
#line 1358 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emmc[[which.max(sc)]], data=EMMsim_train)


###################################################
### chunk number 29: 
###################################################
#line 1395 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
data(Derwent)
summary(Derwent)


###################################################
### chunk number 30: Derwent1
###################################################
#line 1408 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(Derwent[,1], type="l", ylab="Gauged flow", 
main=colnames(Derwent)[1])


###################################################
### chunk number 31: Derwent_cluster_counts
###################################################
#line 1433 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
Derwent_scaled <- scale(Derwent)
emm <- EMM(measure="euclidean", threshold=3)
build(emm, Derwent_scaled)
#cluster_counts(emm)
#state_centers(emm)
plot(emm, method = "cluster_counts", log="y")


###################################################
### chunk number 32: Derwent_EMM1
###################################################
#line 1453 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emm)


###################################################
### chunk number 33: Derwent_EMM2
###################################################
#line 1488 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
rare_threshold <- sum(cluster_counts(emm))*0.005
rare_threshold
plot(prune(copy(emm), rare_threshold))


###################################################
### chunk number 34: Derwent2
###################################################
#line 1510 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
catchment <- 1 
plot(Derwent[,catchment], type="l", ylab="Gauged flows", 
main=colnames(Derwent)[catchment])
state_sequence <- find_clusters(emm, Derwent_scaled)

mark_states <- function(states, state_sequence, ys, col=0, label=NULL, ...) {
    x <- which(state_sequence %in% states)
    points(x, ys[x], col=col, ...)
    if(!is.null(label)) text(x, ys[x], label, pos=4, col=col)
}

mark_states("11", state_sequence, Derwent[,catchment], col="blue", label="11")
mark_states("12", state_sequence, Derwent[,catchment], col="red", label="12")
#mark_states("9", state_sequence, Derwent[,catchment], col="green", label="9")
#mark_states("3", state_sequence, Derwent[,catchment], col="blue")


###################################################
### chunk number 35: Derwent3
###################################################
#line 1551 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
catchment <- 6 
plot(Derwent[,catchment], type="l", ylab="Gauged flow", 
main=colnames(Derwent)[catchment])

mark_states("11", state_sequence, Derwent[,catchment], col="blue", label="11")
mark_states("12", state_sequence, Derwent[,catchment], col="red", label="12")
#mark_states("9", state_sequence, Derwent[,catchment], col="green", label="9")
#mark_states("3", state_sequence, Derwent[,catchment], col="blue")


###################################################
### chunk number 36: 
###################################################
#line 1639 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
data("16S")

emm <- EMM(threshold=0.1, "Kullback")
build(emm, Mollicutes16S+1)


###################################################
### chunk number 37: Mollicutes_graph
###################################################
#line 1646 "d:/Rcompile/CRANpkg/local/2.12/rEMM/inst/doc/rEMM.Rnw"
plot(emm, method = "graph")
## start state for sequences have an initial state probability >0
it <- initial_transition(emm)
it[it>0]


